/* Terminator overlay
 * Copyright (C) 2009 Isana Kashiwai <isana@lizard-tail.com>
 * GPL license
 */

// modified and adapted by Emanuele Traballoni

Ephemeris=function(){},Ephemeris.prototype.JulianDay=function(n){var r,u,f,t,i,e;n=new Date,n.setTime(n.getTime());var r=n.getUTCFullYear(),u=n.getUTCMonth()+1,s=n.getUTCDate(),o="";return u>2||(r=r-1,u=u+12),f=Math.floor(365.25*(r+4716))+Math.floor(30.6001*(u+1))+s-1524.5,o=="julian"?i=0:o=="gregorian"?(t=Math.floor(r/100),i=2-t+Math.floor(t/4)):f<2299160.5?i=0:(t=Math.floor(r/100),i=2-t+Math.floor(t/4)),e=f+i,this.jd=e,e},Ephemeris.prototype.GMST=function(n){var r=3600,i;n=new Date,n.setTime(n.getTime());var o=n.getUTCHours(),s=n.getUTCMinutes(),a=n.getUTCSeconds(),c=o*r+s*60+a,l=new Ephemeris,h=l.JulianDay(n),u=Math.PI/180,v=180/Math.PI,t=(h-2451545)/36525,f=(24110.5484+8640184.812866*t+.093104*t*t+62e-7*t*t*t)/r;return f>24&&(f=f%24),this.gmst_at_zero=f,i=f+c*1.00273790925/r,e=23+26/60+21.448/r-46.815/r*t-.00059/r*t*t+.001813/r*t*t*t,omega=125.04452-1934.136261*t+.0020708*t*t+t*t*t/45e4,long1=280.4665+36000.7698*t,long2=218.3165+481267.8813*t,phai=-17.2*Math.sin(omega*u)- -1.32*Math.sin(2*long1*u)-.23*Math.sin(2*long2*u)+.21*Math.sin(2*omega*u),i=i+phai/15*Math.cos(e*u)/r,i<0&&(i=i%24+24),i>24&&(i=i%24),this.gmst=i,i},Ephemeris.prototype.Sun=function(n){var a=3600,u=360,e=this,r,v,c,l,s,f,y;n=new Date,n.setTime(n.getTime());var d=n.getUTCHours(),k=n.getUTCMinutes(),g=n.getUTCSeconds(),it=d/24+k/1440+g/86400,rt=e.JulianDay(n),i=Math.PI/180,t=(rt+it-2451545)/36525,o=280.46646+36000.76983*t+.0003032*t*t;o<0&&(o=o%u+u),o>u&&(o=o%u),r=357.52911+35999.05029*t-.0001537*t*t,r<0&&(r=r%u+u),r>u&&(r=r%u),v=.016708634-42037e-9*t-1267e-10*t*t,c=(1.914602-.004817*t-14e-6*t*t)*Math.sin(r*i),c+=(.019993-.000101*t)*Math.sin(2*r*i),c+=.000289*Math.sin(3*r*i);var b=o+c,tt=r+c,w=1.000001018*(1-v*v)/(1+v*Math.cos(tt*i));e.radius=w,l=w*149597870,e.distance=l;var p=125.04-1934.136*t,nt=b-.00569-.00478*Math.sin(p*i),h=nt;return e.longitude=h,s=23+26/60+21.448/a-46.815/a*t-.00059/a*t*t+.001813/a*t*t*t,s=s+.00256*Math.cos(p*i),f=Math.atan2(Math.cos(s*i)*Math.sin(h*i),Math.cos(h*i)),f=f/i,f<0&&(f=f+u),f>u&&(f=f%u),e.ra=f/15,y=Math.asin(Math.sin(s*i)*Math.sin(h*i)),e.dec=y/i,e.x=l*Math.cos(h*i),e.y=l*Math.sin(h*i)*Math.cos(s*i),e.z=l*Math.sin(h*i)*Math.sin(s*i),e},Terminator=function(n){this.date=n},Terminator.prototype.generate=function(){var r=360,e=this,u,a,v,y;date=e.date;var n=Math.PI/180,p=new Ephemeris,w=p.Sun(date),k=w.ra,b=w.dec,d=p.GMST(date),t=-(d*15-k*15);t>r&&(t=t%r),t<0&&(t=t%r+r),u=b,e.sunLatLng=new GLatLng(u,t),a=u>5?"south":u<-5?"north":"none";var o=function(f,e,o){var h=this,l=[],c=[],a;for(i=f;i<=e;i+=1){a=Math.asin(Math.cos(u*n)*Math.sin(i*n))/n;if(Math.abs(a)<85){var y=-Math.cos(t*n)*Math.sin(u*n)*Math.sin(i*n)-Math.sin(t*n)*Math.cos(i*n),v=-Math.sin(t*n)*Math.sin(u*n)*Math.sin(i*n)+Math.cos(t*n)*Math.cos(i*n),s=Math.atan2(v,y)/n;s>r&&(s=s%r),s<0&&(s=s%r+r),l.push(a),c.push(s)}}return o==!0?(h.lat_array=l.reverse(),h.lng_array=c.reverse()):(h.lat_array=l,h.lng_array=c),h},f=o(0,90,!0),l=f.lat_array,c=f.lng_array,f=o(270,r,!0);l=l.concat(f.lat_array),c=c.concat(f.lng_array);var f=o(90,180,!1),s=f.lat_array,h=f.lng_array,f=o(180,270,!1);return s=s.concat(f.lat_array),h=h.concat(f.lng_array),u<0?(s.reverse(),h.reverse()):u>0&&(l.reverse(),c.reverse()),v=l.concat(s),y=c.concat(h),e.latitude_array=v,e.longitude_array=y,e.polar_night_flag=a,e},Terminator.prototype.split=function(){var s=this,v=s.generate(),u=v.longitude_array,h=v.latitude_array,p=u.length,l=u[0],o=u[p-1],t=15,e,n,a;l>t?(e=Math.floor(l/t)*t+t,e>0||(e=360)):e=t;var y=Math.floor(o/t)*t+t,w=function(n,t,i,r,u){var f,e;return f=u==360?360:0,e=n+(u-t)*((i-n)/(r+f-t))},r=[],f=[],c=function(e,o,s,c){var l=this;for(n=e;n<=o;n=n+t)for(r[s]=[],f[s]=[],i=c;i<p;i++)if(n>u[i]&&n-t<u[i])r[s].push(u[i]),f[s].push(h[i]);else{var a=w(h[i-1],u[i-1],h[i],u[i],n);r[s].push(n),f[s].push(a),c=i,s++;break}l.splitted_lng_array=r,l.splitted_lat_array=f,l.split_point=n,l.split_count=s,l.next=c};l<o?n=new c(e,y,0,0):(n=new c(e,360,0,0),n=new c(t,y,n.split_count,n.next));var r=n.splitted_lng_array,f=n.splitted_lat_array,b=r.length;for(i=1;i<b;i++)o=r[i-1][r[i-1].length-1],a=f[i-1][f[i-1].length-1],o==360&&(o=0),r[i].unshift(o),f[i].unshift(a);return s.splitted_lng_array=r,s.splitted_lat_array=f,s},Terminator.prototype.show=function(){var o=this.split(),h=o.splitted_lng_array,s=o.splitted_lat_array,t=this.polar_night_flag,i,c,a,l,n,e,f,r,u;for(t=="north"?i=85:t=="south"&&(i=-85),c=function(n,r,u){var f=[],o=n.length,s=r.length,e;if(o>0){for(t!="none"&&f.push(new GLatLng(i,n[0])),f.push(new GLatLng(u,n[0])),e=0;e<s;e++)f.push(new GLatLng(r[e],n[e]));f.push(new GLatLng(u,n[o-1])),t!="none"&&f.push(new GLatLng(i,n[o-1])),f.push(f[0])}return this.polygon=f,this},night_polygon_array=[],polys=[],a=s[0][0],l=h.length,n=0;n<l;n++)e=new c(h[n],s[n],a),night_polygon_array[n]=e.polygon;for(f=night_polygon_array.length,r=0;r<f;r++)u=new GPolygon(night_polygon_array[r],"#000000",1,0,"#000000",map.getCurrentMapType()==G_SATELLITE_MAP||map.getCurrentMapType()==G_HYBRID_MAP||map.getCurrentMapType()==BING_AERIAL||map.getCurrentMapType()==BING_HYBRID?.55:.45,{clickable:!1}),map.addOverlay(u),polys.push(u)},Terminator.prototype.hide=function(){for(var n=0;n<night_polygon_array.length;n++)map.removeOverlay(polys[n])};var night_polygon_array=[],polys=[]